import java.util.ArrayList;
import java.util.Hashtable;

public class BirthdayBook {
	Hashtable<String, Birthday> book;
	
	BirthdayBook() {
		book = new Hashtable<>();
	}
	
	void addBirthday(String name, Birthday bd) {
		book.put(name, bd);
	}
	
	void addBirthday(String name, int month, int day) {
		book.put(name, new Birthday(month, day));
	}
	
	Birthday getBirthday(String name) {
		return book.get(name);
	}
	
	int getNumberOfEntries() {
		return book.size();
	}
	
	String getDescription() {
		String result = "";
		if(getNumberOfEntries() == 0) {
			result += "The birthday book is empty";
		}
		else {
			result += "The birthday book has " + getNumberOfEntries() + " entries:\n";
			for(String name : book.keySet()) {
				Birthday bd = book.get(name);
				result += name + ": " + intToMonth(bd.getMonth()) + " " + bd.getDay() + "\n";
			}
		}
		return result;
	}
	
	String intToMonth(int m) {
		String month = "";
		if(m == 1) {
			month = "January";
		}
		else if(m == 2) {
			month = "February";
		}
		else if(m == 3) {
			month = "March";
		}
		else if(m == 4) {
			month = "April";
		}
		else if(m == 5) {
			month = "May";
		}
		else if(m == 6) {
			month = "June";
		}
		else if(m == 7) {
			month = "July";
		}
		else if(m == 8) {
			month = "August";
		}
		else if(m == 9) {
			month = "September";
		}
		else if(m == 10) {
			month = "October";
		}
		else if(m == 11) {
			month = "November";
		}
		else {
			month = "December";
		}
		
		return month;
	}
	
	ArrayList<String> getReminders(Birthday bd) {
		ArrayList<String> list = new ArrayList<>();
		
		for(String name : book.keySet()) {
			Birthday bd2 = book.get(name);
			if(bd2.getDay() == bd.getDay() && bd2.getMonth() == bd.getMonth()) {
				list.add(name);
			}
		}
		
		return list;
	}
}
